<script src="./Script.js"></script>

<template>
  <div class="nt-list-attribute-settings">
    <div class="text-right m--margin-bottom-20">
      <button
        data-toggle="modal"
        data-target="#addAttributeDeal"
        class="nt-button nt-button-secondary nt-button-small d-inline-block"
      >
        <i class="la la-plus"></i> Thêm trường dữ liệu
      </button>
    </div>
    <div v-if="attributes && attributes.length <= 0" class="nt-table-list-attribute">
      <h3 class="nt-color-primary w-100 text-center">Không có trường tùy chỉnh nào.</h3>
    </div>

    <div class="nt-list-attribute-settings-wrap nt-scroll-primary">
      <div
        v-if="attributes && attributes.length > 0"
        class="nt-list-attribute-settings-head nt-table-list-attribute"
      >
        <div class="nt-list-attribute-head nt-list-attribute-drag"></div>
        <div class="nt-list-attribute-head nt-list-attribute-action">
          <span class="nt-label">Tác vụ</span>
        </div>
        <div class="nt-list-attribute-head nt-list-attribute-name">
          <span class="nt-label">Tên trường thông tin</span>
        </div>
        <div class="nt-list-attribute-head nt-list-attribute-show-in">
          <span class="nt-label">Hiển thị trong màn hình Chi tiết giao dịch ở tab</span>
        </div>
        <div class="nt-list-attribute-head nt-list-attribute-type">
          <span class="nt-label">Kiểu điền thông tin</span>
        </div>
        <div class="nt-list-attribute-head nt-list-attribute-required">
          <span class="nt-label">Bắt buộc điền</span>
        </div>
        <div class="nt-list-attribute-head nt-list-attribute-unique">
          <span class="nt-label">Không cho trùng thông tin</span>
        </div>
        <div class="nt-list-attribute-head nt-list-attribute-hidden">
          <span class="nt-label">Ẩn/hiện trường</span>
        </div>
      </div>
      <vue-nestable
        class="nt-list-attribute-settings-content"
        v-model="attributes"
        key-prop="id"
        :threshold="0"
        children-prop="childrens"
        :max-depth="1"
        v-if="attributes && attributes.length > 0"
        @change="sortNestedData()"
      >
        <template slot-scope="{ item }">
          <div class="nt-settings-multiple-item nt-table-list-attribute">
            <div class="nt-list-attribute-drag">
              <vue-nestable-handle v-if="item.id" :item="item">
                <div class="nt-settings-multiple-item-drag">
                  <i class="icon icon-scroll nt-settings-multiple-item-drag-icon"></i>
                </div>
              </vue-nestable-handle>
            </div>
            <div class="nt-table-list-attribute-content nt-list-attribute-action">
              <button
                aria-expanded="true"
                aria-haspopup="true"
                data-toggle="dropdown"
                class="btn m-btn--icon nt-settings-multiple-item-dropdown"
              >
                <i class="la la-ellipsis-h"></i>
              </button>
              <div class="dropdown-menu nt-settings-multiple-item-dropdown-wrap">
                <span class="nt-settings-arrow-up"></span>
                <a href="javascript:;" class="dropdown-item" @click.prevent="showEditPopup(item)">
                  <i class="icon icon-pencil"></i>
                  Chỉnh sửa
                </a>
                <a href="javascript:;" @click.prevent="deleteItem(item)" class="dropdown-item">
                  <i class="icon icon-trash"></i>
                  Xóa
                </a>
              </div>
            </div>
            <div class="nt-table-list-attribute-content nt-list-attribute-name">
              <span class="nt-label">{{item.attribute_name | truncateWords }}</span>
            </div>
            <div class="nt-table-list-attribute-content nt-list-attribute-show-in">
              <div
                style="margin-bottom: 3px; margin-right: 3px; background: #FFFFFF;"
                class="nt-barge-dropdown"
              >Thông tin mở rộng</div>
            </div>
            <div class="nt-table-list-attribute-content nt-list-attribute-type">
              <span class="nt-label">{{getDataType(item.data_type.id) | truncateWords }}</span>
            </div>
            <div class="nt-table-list-attribute-content nt-list-attribute-required">
              <span class="m-switch m-switch--outline m-switch--success">
                <label @mousedown="switchCheckbox(item, 'required')">
                  <input
                    :disabled="item.data_type_id === isRadio"
                    type="checkbox"
                    v-model="item.is_required"
                    :id="'custom_attribute_required' + item.id"
                    :name="'custom_attribute_required' + item.id"
                  />
                  <span></span>
                </label>
              </span>
            </div>
            <div class="nt-table-list-attribute-content nt-list-attribute-unique">
              <span class="m-switch m-switch--outline m-switch--success">
                <label @mousedown="switchCheckbox(item, 'unique')">
                  <input
                    :disabled="item.data_type_id === isRadio || item.data_type_id !== isText && item.data_type_id !== isEmail && item.data_type_id !== isPhone"
                    type="checkbox"
                    v-model="item.is_unique"
                    :id="'custom_attribute_unique' + item.id"
                    :name="'custom_attribute_unique' + item.id"
                  />
                  <span></span>
                </label>
              </span>
            </div>
            <div class="nt-table-list-attribute-content nt-list-attribute-hidden">
              <span class="m-switch m-switch--outline m-switch--success">
                <!-- v-model="!item.is_hidden" -->
                <label @mousedown="switchCheckbox(item, 'hidden')">
                  <input
                    type="checkbox"
                    v-model="item.is_hidden"
                    :id="'custom_attribute_hidden' + item.id"
                    :name="'custom_attribute_hidden' + item.id"
                  />
                  <span></span>
                </label>
              </span>
            </div>
          </div>
        </template>
      </vue-nestable>
    </div>

    <!--Delete Attribute-->
    <div
      id="deleteDealAttribute"
      data-backdrop="static"
      data-keyboard="false"
      class="modal s--modal fade nt--modal-confirm-choice s--modal-delete-custom-attribute"
    >
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-body">
            <!--<h3 class="nt&#45;&#45;modal-confirm-choice-title">-->
            <!--Thông báo-->
            <!--</h3>-->
            <div class="nt--modal-confirm-choice-content">
              <div class="nt--modal-confirm-choice-content-title-top" v-if="selectedItem">
                Xóa trường
                <span class="nt-color-warning">{{ selectedItem.attribute_name }}</span>?
              </div>

              <div
                class="nt--modal-confirm-choice-content-title-bottom nt-color-warning"
              >Tất cả dữ liệu trường thông tin này đã lưu sẽ bị xóa, và bạn không thể lấy lại dữ liệu này.</div>
            </div>
          </div>
          <div class="modal-footer">
            <button
              class="nt-button nt-button-secondary mr-2"
              data-dismiss="modal"
              aria-label="Close"
            >Hủy bỏ</button>
            <button
              @click.prevent="deleteDealAttribute()"
              class="nt-button nt-button-warning mr-0"
              data-dismiss="modal"
            >Xóa</button>
          </div>
        </div>
      </div>
    </div>

    <!--Change required attribute-->
    <div
      id="modalRequireAttribute"
      data-backdrop="static"
      data-keyboard="false"
      class="modal s--modal fade nt--modal-confirm-choice s--modal-change-required-custom-attribute"
    >
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-body">
            <!--<h3 class="nt&#45;&#45;modal-confirm-choice-title">-->
            <!--Thông báo-->
            <!--</h3>-->
            <div class="nt--modal-confirm-choice-content" v-if="selectedItem">
              <template v-if="selectedItem.is_required">
                <div class="nt--modal-confirm-choice-content-title-top">
                  Trường
                  <span class="nt-color-warning">{{selectedItem.attribute_name}}</span> sẽ chuyển thành không bắt buộc điền?
                </div>
                <div
                  class="nt--modal-confirm-choice-content-title-bottom nt-color-warning"
                >Khi Thêm giao dịch, Sửa thông tin giao dịch, sẽ không bắt buộc điền dữ liệu cho trường này.</div>
              </template>
              <template v-else>
                <div class="nt--modal-confirm-choice-content-title-top">
                  Trường
                  <span class="nt-color-warning">{{selectedItem.attribute_name}}</span> sẽ chuyển thành bắt buộc điền?
                </div>
                <div
                  class="nt--modal-confirm-choice-content-title-bottom nt-color-warning"
                >Khi Thêm giao dịch, Sửa thông tin giao dịch, sẽ bắt buộc điền dữ liệu cho trường này.</div>
              </template>
            </div>
          </div>
          <div class="modal-footer">
            <button
              class="nt-button nt-button-secondary mr-2"
              data-dismiss="modal"
              aria-label="Close"
            >Hủy bỏ</button>
            <button
              @click.prevent="requiredAttributeItem()"
              class="nt-button nt-button-warning mr-0"
              data-dismiss="modal"
            >Đồng ý</button>
          </div>
        </div>
      </div>
    </div>

    <!--Change unique attribute-->
    <div
      id="modalUniqueAttribute"
      data-backdrop="static"
      data-keyboard="false"
      class="modal s--modal fade nt--modal-confirm-choice s--modal-confirm-choice s--modal-change-unique-custom-attribute"
    >
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-body">
            <!--<h3 class="nt&#45;&#45;modal-confirm-choice-title">-->
            <!--Thông báo-->
            <!--</h3>-->
            <div class="nt--modal-confirm-choice-content" v-if="selectedItem">
              <template v-if="selectedItem.is_unique">
                <div class="nt--modal-confirm-choice-content-title-top">
                  Trường
                  <span class="nt-color-warning">{{selectedItem.attribute_name}}</span> sẽ không cho trùng dữ liệu?
                </div>
                <div
                  class="nt--modal-confirm-choice-content-title-bottom nt-color-warning"
                >Khi Thêm giao dịch, Sửa thông tin giao dịch, trường này sẽ không kiểm tra dữ liệu có trùng hay không.</div>
              </template>
              <template v-else>
                <div class="nt--modal-confirm-choice-content-title-top">
                  Trường
                  <span class="nt-color-warning">{{selectedItem.attribute_name}}</span> sẽ cho trùng dữ liệu?
                </div>
                <div
                  class="nt--modal-confirm-choice-content-title-bottom nt-color-warning"
                >Khi Thêm giao dịch, Sửa thông tin giao dịch, trường này sẽ kiểm tra dữ liệu và không cho phép trùng.</div>
              </template>
            </div>
          </div>
          <div class="modal-footer">
            <button
              class="nt-button nt-button-secondary mr-2"
              data-dismiss="modal"
              aria-label="Close"
            >Hủy bỏ</button>
            <button
              @click.prevent="uniqueAttributeItem()"
              class="nt-button nt-button-warning mr-0"
              data-dismiss="modal"
            >Đồng ý</button>
          </div>
        </div>
      </div>
    </div>

    <!--Change show hide attribute-->
    <div
      id="modalHiddenAttribute"
      data-backdrop="static"
      data-keyboard="false"
      class="modal s--modal fade nt--modal-confirm-choice s--modal-change-show-hide-custom-attribute"
    >
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-body">
            <!--<h3 class="nt&#45;&#45;modal-confirm-choice-title">-->
            <!--Thông báo-->
            <!--</h3>-->
            <div class="nt--modal-confirm-choice-content" v-if="selectedItem">
              <template v-if="!selectedItem.is_hidden">
                <div class="nt--modal-confirm-choice-content-title-top">
                  Hiện trường
                  <span class="nt-color-warning">{{selectedItem.attribute_name}}</span>?
                </div>
                <div
                  class="nt--modal-confirm-choice-content-title-bottom nt-color-warning"
                >Trường này sẽ hiển thị trong các màn hình Danh sách giao dịch, Thêm giao dịch, Sửa thông tin giao dịch, Xem chi tiết giao dịch.</div>
              </template>
              <template v-else>
                <div class="nt--modal-confirm-choice-content-title-top">
                  Ẩn trường
                  <span class="nt-color-warning">{{selectedItem.attribute_name}}</span>?
                </div>
                <div
                  class="nt--modal-confirm-choice-content-title-bottom nt-color-warning"
                >Trường này sẽ không hiển thị trong các màn hình Danh sách giao dịch, Thêm giao dịch, Sửa thông tin giao dịch, Xem chi tiết giao dịch.</div>
              </template>
            </div>
          </div>
          <div class="modal-footer">
            <button
              class="nt-button nt-button-secondary mr-2"
              data-dismiss="modal"
              aria-label="Close"
            >Hủy bỏ</button>
            <button
              @click.prevent="showHideAttributeItem()"
              class="nt-button nt-button-warning mr-0"
              data-dismiss="modal"
            >
              <template v-if="selectedItem && selectedItem.is_hidden">Ẩn</template>
              <template v-else>Hiện</template>
            </button>
          </div>
        </div>
      </div>
    </div>

    <add-new-attribute-deal @is_success="isSuccessAction()"></add-new-attribute-deal>
    <edit-attribute-deal
      v-if="selectedItem != null"
      :attribute="selectedItem"
      :cache_name_attributes="cacheAttributeOptionsName"
      @is_success="isSuccessAction()"
      @is_cancel="isCancel"
    ></edit-attribute-deal>
  </div>
</template>
